import ZeotapCollect

@objc(ZeoCollect)
class ZeoCollect: NSObject {    
    
    @objc func setEventProperties(_ eventName: String, event eventProp: NSDictionary) {
      let prop = eventProp as! Dictionary<String,NSObject>
      if !prop.isEmpty {
        Collect.getInstance()?.setEventProperties(eventName, prop)
      }
    }
    
    @objc func setEventNameProperties(_ eventName: String) {
      Collect.getInstance()?.setEventProperties(eventName)
    }
    
    @objc func setInstantEventNameProperties(_ eventName: String) {
      Collect.getInstance()?.setInstantEventProperties(eventName)
    }
    
    @objc func setInstantEventProperties(_ eventName: String, event eventProp: [String: NSObject]) {
      Collect.getInstance()?.setInstantEventProperties(eventName, eventProp)
    }
    
    @objc func setUserProperties(_ user: [String: NSObject]) {
      Collect.getInstance()?.setUserProperties(user)
    }
    
    @objc func setPageProperties(_ page: [String: NSObject]) {
      Collect.getInstance()?.setPageProperties(page)
    }
    
    @objc func setUserIdentities(_ user: [String: NSObject]) {
      Collect.getInstance()?.setUserIdentities(user)
    }
    
    @objc func setConsent(_ consent: [String: NSObject]) {
      Collect.getInstance()?.setConsent(consent: consent)
    }
    
    @objc func addAskForConsentListener(_ cb: @escaping RCTResponseSenderBlock) {
      Collect.getInstance()?.listenToAskForConsent(action: { _data in
        cb([])
      })
    }
    
    @objc func unsetUserIdentities() {
      Collect.getInstance()?.unsetUserIdentities()
    }
    
    @objc func deInitiate() {
      Collect.getInstance()?.pauseCollection()
    }
    
    @objc func reInitialize() {
      Collect.getInstance()?.resumeCollection()
    }
    
    @objc func getZI(_ callback: @escaping RCTResponseSenderBlock) {
      let zi = Collect.getInstance()?.getZI()
      callback([zi ?? ""])
    }
    
    @objc func resetZI() {
      Collect.getInstance()?.resetZI()
    }
    
}
